Package org.springframework.security.authentication

# Interface AuthenticationManager

All Known Implementing Classes:
  `ObservationAuthenticationManager`, `ProviderManager`

Functional Interface:
  This is a functional interface and can therefore be used as the assignment target for a lambda expression or method reference.

@FunctionalInterface public interface AuthenticationManager
Processes an `Authentication` request.

## Method Summary

Modifier and Type
Method
Description
`Authentication`
`authenticate(Authentication authentication)`
Attempts to authenticate the passed `Authentication` object, returning a fully populated `Authentication` object (including granted authorities) if successful.

## Method Details

### authenticate

Authentication authenticate(Authentication authentication) throws AuthenticationException
Attempts to authenticate the passed `Authentication` object, returning a fully populated `Authentication` object (including granted authorities) if successful.

An `AuthenticationManager` must honour the following contract concerning exceptions:

- A `DisabledException` must be thrown if an account is disabled and the `AuthenticationManager` can test for this state.
- A `LockedException` must be thrown if an account is locked and the `AuthenticationManager` can test for account locking.
- A `BadCredentialsException` must be thrown if incorrect credentials are presented. Whilst the above exceptions are optional, an `AuthenticationManager` must always test credentials.

Exceptions should be tested for and if applicable thrown in the order expressed above (i.e. if an account is disabled or locked, the authentication request is immediately rejected and the credentials testing process is not performed). This prevents credentials being tested against disabled or locked accounts.

Parameters:
  `authentication` - the authentication request object
Returns:
  a fully authenticated object including credentials
Throws:
  `AuthenticationException` - if authentication fails